searchData={"items":[{"type":"module","title":"Paypal.Common.Error.Details","doc":"Each detail implemented for the error.","ref":"Paypal.Common.Error.Details.html"},{"type":"type","title":"Paypal.Common.Error.Details.t/0","doc":"The information for each line of the error, it includes: field,\ndescription, issue, location, and value.","ref":"Paypal.Common.Error.Details.html#t:t/0"},{"type":"module","title":"Paypal.Order.Authorization.SellerProtection","doc":"Seller protection gives us information about if the protection of the\nseller is elegible and the categories for the disputes.","ref":"Paypal.Order.Authorization.SellerProtection.html"},{"type":"type","title":"Paypal.Order.Authorization.SellerProtection.t/0","doc":"Seller protection gives us the eligibility of the seller and the kind\nof disputes.","ref":"Paypal.Order.Authorization.SellerProtection.html#t:t/0"},{"type":"module","title":"Paypal.Order.Authorized.PurchaseUnit","doc":"Purchase Unit has the information for each detail line in the bought items.","ref":"Paypal.Order.Authorized.PurchaseUnit.html"},{"type":"type","title":"Paypal.Order.Authorized.PurchaseUnit.t/0","doc":"Information about the purchase units, each purchase unit has a reference\nand a payment.","ref":"Paypal.Order.Authorized.PurchaseUnit.html#t:t/0"},{"type":"module","title":"Paypal.Order.Authorized.PurchaseUnit.Payment","doc":"The payment define the list of authorizations that are included inside\nof the authorized order.","ref":"Paypal.Order.Authorized.PurchaseUnit.Payment.html"},{"type":"type","title":"Paypal.Order.Authorized.PurchaseUnit.Payment.t/0","doc":"The payment has only a list of authorizations, check `Authorization` for\nfurther details.","ref":"Paypal.Order.Authorized.PurchaseUnit.Payment.html#t:t/0"},{"type":"module","title":"Paypal.Auth","doc":"Paypal requires to have an authenticated token to interact. This module\nhelps to generate a token time to time (before it's expired) and ensure\nwe have always the correct one.","ref":"Paypal.Auth.html"},{"type":"function","title":"Paypal.Auth.get_token/0","doc":"Get active token.","ref":"Paypal.Auth.html#get_token/0"},{"type":"function","title":"Paypal.Auth.get_token!/0","doc":"Get token and fails if there's no token.","ref":"Paypal.Auth.html#get_token!/0"},{"type":"module","title":"Paypal.Auth.Access","doc":"The access structure has the information for accessing to the rest of\nthe requests and the information about the expiration of the token.","ref":"Paypal.Auth.Access.html"},{"type":"function","title":"Paypal.Auth.Access.cast/2","doc":"Perform the transformation of the input data from the Paypal server to the\naccess struct.","ref":"Paypal.Auth.Access.html#cast/2"},{"type":"type","title":"Paypal.Auth.Access.t/0","doc":"The information stored inside of the access structure is the following:\n\n- `scope` is a list of URLs we can access or use with the access token.\n- `access_token` is the hash we need for the other requests.\n- `token_type` is the type of the token generated. Usually it's `Bearer`.\n- `app_id` is the ID of the application.\n- `expires_in` is the number of seconds for expiring the token.\n- `nonce` is the nonce used.","ref":"Paypal.Auth.Access.html#t:t/0"},{"type":"module","title":"Paypal.Auth.Request","doc":"Paypal requires to have an authenticated token to interact. This module\nhelps to generate a token time to time (before it's expired) and ensure\nwe have always the correct one.","ref":"Paypal.Auth.Request.html"},{"type":"function","title":"Paypal.Auth.Request.auth/0","doc":"Perform the authorization and retrieve the response.","ref":"Paypal.Auth.Request.html#auth/0"},{"type":"module","title":"Paypal.Auth.Worker","doc":"The worker is performing the refresh of the token.","ref":"Paypal.Auth.Worker.html"},{"type":"function","title":"Paypal.Auth.Worker.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Paypal.Auth.Worker.html#child_spec/1"},{"type":"function","title":"Paypal.Auth.Worker.get_token/0","doc":"Get the access token stored in the worker.","ref":"Paypal.Auth.Worker.html#get_token/0"},{"type":"function","title":"Paypal.Auth.Worker.refresh/0","doc":"Performs a manual refresh for the access token.","ref":"Paypal.Auth.Worker.html#refresh/0"},{"type":"type","title":"Paypal.Auth.Worker.t/0","doc":"The internal structure for the auth of Paypal is composed of\na `access` entry (see `Paypal.Auth.Access.t()` for further information),\nand `timer_ref`, a reference for the current and active timer.","ref":"Paypal.Auth.Worker.html#t:t/0"},{"type":"module","title":"Paypal.Order","doc":"The orders is the element that let us to charge an amount to the clients.\n\nWe have to ways to proceed, it's called the `intent` and depending on what\nyou choose, it will let you charge the money instantly or hold the money\nuntil the process, product or service will be released.\n\n- `capture` is the intent that charge the money immediately. The flow is:\n  1. Crete the order using `capture` as the intent, see `create/2`.\n  2. Use the URL inside of the response for approving the payment.\n  3. Capture the money, see `capture/1`.\n\n- `authorize` is the intent that hold the money and it will let you capture\n  the fonds later. The flow is:\n  1. Create the order using `authorize` as the intent, see `create/2`.\n  2. Use the URL inside of the response for approving the payment.\n  3. Create the authorization, see `authorize/1`.\n  4. Capture fonds using the authorization, see `Paypal.Payment.capture/1`.\n\nIf you are interested on the authorization, check `Paypal.Payment` module for\nfurther information.","ref":"Paypal.Order.html"},{"type":"function","title":"Paypal.Order.authorize/1","doc":"","ref":"Paypal.Order.html#authorize/1"},{"type":"function","title":"Paypal.Order.capture/1","doc":"","ref":"Paypal.Order.html#capture/1"},{"type":"function","title":"Paypal.Order.create/3","doc":"Create an order.","ref":"Paypal.Order.html#create/3"},{"type":"function","title":"Paypal.Order.intents/0","doc":"The kind of intents, for further information `Paypal.Order`.","ref":"Paypal.Order.html#intents/0"},{"type":"function","title":"Paypal.Order.show/1","doc":"","ref":"Paypal.Order.html#show/1"},{"type":"function","title":"Paypal.Order.statuses/0","doc":"Statuses for the order. The order is following different states, we could\nillustrate it as a state diagram:\n\n```mermaid\nstateDiagram-v2\n    [*] --> CREATED\n    CREATED --> PAYER_ACTION_REQUIRED\n    PAYER_ACTION_REQUIRED --> APPROVED\n    APPROVED --> SAVED\n    SAVED --> APPROVED\n    APPROVED --> VOIDED\n    APPROVED --> COMPLETED\n    VOIDED --> [*]\n    COMPLETED --> [*]\n```\n\nAs you can see, we start in CREATED state and we are moving until reach\nVOIDED or COMPLETED.","ref":"Paypal.Order.html#statuses/0"},{"type":"module","title":"Paypal.Order.Authorization","doc":"Authorization is the information embebed into the\n`Paypal.Order.Authorized` for getting all of the information for the\nauthorized payment.","ref":"Paypal.Order.Authorization.html"},{"type":"type","title":"Paypal.Order.Authorization.t/0","doc":"The information about the authorization performed on an order.\nThe important information here is the `id` because it will be\nimportant to perform actions using `Paypal.Payment` functions.","ref":"Paypal.Order.Authorization.html#t:t/0"},{"type":"module","title":"Paypal.Order.Authorized","doc":"The authorized struct is the response performed by `Paypal.Order.authorize/1`\nwhere we can see the status of the authorization and other information\nrelated to the request.","ref":"Paypal.Order.Authorized.html"},{"type":"type","title":"Paypal.Order.Authorized.t/0","doc":"The information related to the request is returning the order `id`, the final\n`status` for the order and the information for the authorization in the path\n`purchase_units/payments/authorizations`.","ref":"Paypal.Order.Authorized.html#t:t/0"},{"type":"module","title":"Paypal.Order.Create","doc":"Create an order. It contains the information for creating an order.","ref":"Paypal.Order.Create.html"},{"type":"type","title":"Paypal.Order.Create.t/0","doc":"The information for creating an order is based on two principal data:\n\n- `intent` that could be `:capture` or `:authorize`.\n- `purchase_units` that is the information for the payment.\n  See `Paypal.Order.PurchaseUnit`.","ref":"Paypal.Order.Create.html#t:t/0"},{"type":"module","title":"Paypal.Order.ExperienceContext","doc":"The experience context is the information needed for creating an order\nand provide information about how Paypal should behave when we go to its\nwebsite for performing the payment.","ref":"Paypal.Order.ExperienceContext.html"},{"type":"type","title":"Paypal.Order.ExperienceContext.t/0","doc":"The customisation we could perform are the following ones:\n\n- `payment_method_experience` is unrestricted or immediate_payment_required.\n- `brand_name` is your branding that you want to show to your client.\n- `locale` is the language you want to use.\n- `landing_page` is where the user goes first:\n  - `login` if we want the user see the paypal login page first.\n  - `guest_checkout` if we want to Paypal show first the manual payment.\n  - `no_preference` if we want Paypal choose based on the user.\n- `shipping_preference` is an indication about where we get the shipping\n  data we could say here `no_shipping` for avoiding use a shipping address.\n- `user_action` is the action the user could do: continue or pay_now.\n- `return_url` is the URL where redirects when the payment is correct.\n- `cancel_url` is the URL where redirects when the payment is cancelled.","ref":"Paypal.Order.ExperienceContext.html#t:t/0"},{"type":"module","title":"Paypal.Order.Info","doc":"Order information. The information retrieved from Paypal about the order.","ref":"Paypal.Order.Info.html"},{"type":"type","title":"Paypal.Order.Info.t/0","doc":"The information for the order containing:\n\n- `id` is the ID for the order.\n- `create_time` is the date and time when the order was created.\n- `intent` could be `capture` or `authorize`.\n- `links` are the HATEOAS about the following valid actions.\n- `purchase_units` are the units inside of the order.\n- `status` for the order.\n- `payment_source` is a map that should contains the information about\n  how the payment was made. If that was using PayPal credit, or card,\n  or whatever else.","ref":"Paypal.Order.Info.html#t:t/0"},{"type":"module","title":"Paypal.Order.Payer","doc":"Payer get all the information about who's paying the order.","ref":"Paypal.Order.Payer.html"},{"type":"type","title":"Paypal.Order.Payer.t/0","doc":"The information for the payer:\n\n- `payer_id` is the ID in Paypal for the payer.\n- `name` is a composition of two values: given_name and surname.\n- `email_address` is the email address provided to Paypal for the payment.\n- `address` is a map that contains at least `country`.","ref":"Paypal.Order.Payer.html#t:t/0"},{"type":"module","title":"Paypal.Order.PurchaseUnit","doc":"The purchase unit is the information for each unit purchased (or to purchase)\nincluded in an order.","ref":"Paypal.Order.PurchaseUnit.html"},{"type":"type","title":"Paypal.Order.PurchaseUnit.t/0","doc":"The information for the purchase unit. It's composed for the provided\nitems to be purchased, the information about the payee, payment instructions,\nshipping, etc.","ref":"Paypal.Order.PurchaseUnit.html#t:t/0"},{"type":"module","title":"Paypal.Order.PurchaseUnit.Capture","doc":"Represents a Capture object from the PayPal v2 PurchaseUnit API.","ref":"Paypal.Order.PurchaseUnit.Capture.html"},{"type":"module","title":"Fields - Paypal.Order.PurchaseUnit.Capture","doc":"- `id` - The unique ID for the capture.\n  - `status` - The status of the capture (e.g. `\"COMPLETED\"`).\n  - `status_details` - The details of the capture status.\n  - `invoice_id` - The API caller-provided external invoice number for this order.\n  - `custom_id` - The API caller-provided external ID.\n  - `final_capture` - A boolean indicating if this is the final capture.\n  - `create_time` - The date and time when the capture was created (ISO 8601 string).\n  - `update_time` - The date and time when the capture was last updated (ISO 8601 string).\n  - `amount` - An embedded schema representing the monetary amount of the capture.\n  - `disbursement_mode` - An embedded schema containing details about the disbursement mode.\n  - `processor_response` - An embedded schema containing details about the processor response.\n  - `seller_protection` - An embedded schema containing details about seller protection.\n  - `seller_receivable_breakdown` - An embedded schema that details the receivables.\n  - `network_transaction_reference` - Reference values used by the card network to identify a transaction.\n  - `links` - A list of embedded link objects for further API actions.","ref":"Paypal.Order.PurchaseUnit.Capture.html#module-fields"},{"type":"type","title":"Paypal.Order.PurchaseUnit.Capture.t/0","doc":"","ref":"Paypal.Order.PurchaseUnit.Capture.html#t:t/0"},{"type":"module","title":"Paypal.Order.PurchaseUnit.Item","doc":"The item inside of each purchase unit.\nSee `Paypal.Order.PurchaseUnit`.","ref":"Paypal.Order.PurchaseUnit.Item.html"},{"type":"type","title":"Paypal.Order.PurchaseUnit.Item.t/0","doc":"The purchase unit has different items and each item has the following\ninformation:\n\n- `name` of the item.\n- `quantity` of the item included in the order.\n- `description` of the item.\n- `sku` is the ID for the item.\n- `url` is the URL for the item.\n- `category` is the category where the item is included.\n- `image_url` is the URL for the image.\n- `unit_amount` is the price for each unit.\n- `tax` is the price for the taxes.\n- `upc` is the UPC EAN code.","ref":"Paypal.Order.PurchaseUnit.Item.html#t:t/0"},{"type":"module","title":"Paypal.Order.PurchaseUnit.PaymentCollection","doc":"Represents a Payment Collection object from the PayPal v2 API.\n\nThis object holds details about payment captures, refunds, and authorizations.","ref":"Paypal.Order.PurchaseUnit.PaymentCollection.html"},{"type":"type","title":"Paypal.Order.PurchaseUnit.PaymentCollection.t/0","doc":"","ref":"Paypal.Order.PurchaseUnit.PaymentCollection.html#t:t/0"},{"type":"module","title":"Paypal.Order.UpcCode","doc":"The UPC EAN code.","ref":"Paypal.Order.UpcCode.html"},{"type":"type","title":"Paypal.Order.UpcCode.t/0","doc":"It's defining the `type` for the UPC code (i.e. UPC-A) and the `code`.","ref":"Paypal.Order.UpcCode.html#t:t/0"},{"type":"module","title":"Paypal.Payment","doc":"Perform payment actions for Paypal. The payments are authorized orders.\nYou can see further information via `Paypal.Order`.","ref":"Paypal.Payment.html"},{"type":"function","title":"Paypal.Payment.capture/1","doc":"Capture the authorized order. It's the final step to perform a payment with\nan authorized order.","ref":"Paypal.Payment.html#capture/1"},{"type":"function","title":"Paypal.Payment.refund/2","doc":"Performs a refund of the capture that was captured previously.","ref":"Paypal.Payment.html#refund/2"},{"type":"function","title":"Paypal.Payment.show/1","doc":"Show information about the authorized order.","ref":"Paypal.Payment.html#show/1"},{"type":"function","title":"Paypal.Payment.void/1","doc":"Void the authorized order. It's a way for cancel or return the blocked\nor authorized fonds.","ref":"Paypal.Payment.html#void/1"},{"type":"module","title":"Paypal.Payment.Captured","doc":"The returned information after performing a capture of an authorized order.","ref":"Paypal.Payment.Captured.html"},{"type":"type","title":"Paypal.Payment.Captured.t/0","doc":"The information about the captured order is the following one:\n\n- `id` for the authorized order.\n- `invoice_id` (optional) is the provided invoice ID provided when the order\n  was created or authorized.\n- `custom_id` (optional) is the provided custom ID when the order was created\n  or authorized.\n- `final_capture` it's about a fraction of the order to be paid.\n- `links` are the links about the following possible options (HATEOAS).\n- `status` for the authorized order.\n- `status_details` is a string defining the status for the authorized order.\n- `disbursement_mode`\n- `amount` is the price for the order to be paid.\n- `create_time` (optional) is the time when the authorized order was created.\n- `update_time` (optional) is the time when the authorized order was updated.","ref":"Paypal.Payment.Captured.html#t:t/0"},{"type":"module","title":"Paypal.Payment.Info","doc":"Authorized order information.","ref":"Paypal.Payment.Info.html"},{"type":"type","title":"Paypal.Payment.Info.t/0","doc":"The retrieved authorized order information is the following one:\n\n- `id` for the authorized order ID.\n- `create_time` is the date and time when the order was created.\n- `expiration_time` is the date and time when the authorization expires.\n- `amount` is the price to be paid.\n- `links` are the possible actions to follow (HATEOAS).\n- `payee` is the information about who is paying the order.\n- `status` is the status for the authorized order.","ref":"Paypal.Payment.Info.html#t:t/0"},{"type":"module","title":"Paypal.Payment.Refund","doc":"Payment refund information. The information retrieved from Paypal about the\nrefund.","ref":"Paypal.Payment.Refund.html"},{"type":"module","title":"Fields - Paypal.Payment.Refund","doc":"- `id` - The unique ID for the capture.\n  - `status` - The status of the capture (e.g. `\"COMPLETED\"`).\n  - `status_details` - The details of the capture status.\n  - `invoice_id` - The API caller-provided external invoice number for this order.\n  - `custom_id` - The API caller-provided external ID.\n  - `payer` - An embedded schema representing the payer.\n  - `create_time` - The date and time when the capture was created (ISO 8601 string).\n  - `update_time` - The date and time when the capture was last updated (ISO 8601 string).\n  - `amount` - An embedded schema representing the monetary amount of the capture.\n  - `acquirer_reference_number` - Reference ID issued for the card transaction.\n  - `note_to_payer` - The reason for the refund.\n  - `seller_protection` - An embedded schema containing details about seller protection.\n  - `seller_payable_breakdown` - An embedded schema that details the seller_payable_breakdown.\n  - `links` - A list of embedded link objects for further API actions.","ref":"Paypal.Payment.Refund.html#module-fields"},{"type":"type","title":"Paypal.Payment.Refund.t/0","doc":"","ref":"Paypal.Payment.Refund.html#t:t/0"},{"type":"module","title":"Paypal.Payment.RefundRequest","doc":"Request object that Refunds a captured payment, by ID. For a full refund,\ninclude an empty request body. For a partial refund, include an `amount`\nobject in the request body.","ref":"Paypal.Payment.RefundRequest.html"},{"type":"module","title":"Fields - Paypal.Payment.RefundRequest","doc":"- `amount` - The currency and amount for a financial transaction, such as\n    a balance or payment due.\n  - `custom_id` - The API caller-provided external ID. Used to reconcile API\n    caller-initiated transactions with PayPal transactions.\n  - `invoice_id` - The API caller-provided external invoice ID for this order.\n  - `note_to_payer` - The reason for the refund. Appears in both the payer's\n    transaction history and the emails that the payer receives.\n  - `payment_instruction` - Any additional payments instructions during refund\n    payment processing.","ref":"Paypal.Payment.RefundRequest.html#module-fields"},{"type":"type","title":"Paypal.Payment.RefundRequest.t/0","doc":"","ref":"Paypal.Payment.RefundRequest.html#t:t/0"},{"type":"module","title":"Paypal.Common.CurrencyValue","doc":"Most of the currencies in the Paypal requests and responses are handled\nas a JSON object that is including `currency_code` and `value`. But it's\neven more complex in other requests.\n\nThis struct contains the possibilities for all of these requests/responses.","ref":"Paypal.Common.CurrencyValue.html"},{"type":"type","title":"Paypal.Common.CurrencyValue.t/0","doc":"The type is composed by the following:\n\n- `currency_code` is the currency code based on ISO-4217, i.e. EUR\n- `value` is the decimal or integer value for the currency.\n- `breakdown` is expressing information for the money.\n\nAbout the breakdown, we could find that if it's provided, it could include\ninformation like this one:\n\n```elixir\n%{\n  \"item_total\" => %{\n    \"currency_code\" => \"EUR\",\n    \"value\" => \"12.00\"\n  },\n  \"shipping\" => %{\n    \"currency_code\" => \"EUR\",\n    \"value\" => \"2.00\"\n  },\n  \"discount\" => {\n    \"currency_code\" => \"EUR\",\n    \"value\" => \"5.00\"\n  }\n}\n```","ref":"Paypal.Common.CurrencyValue.html#t:t/0"},{"type":"module","title":"Paypal.Common.Error","doc":"When something goes wrong, Paypal is replying us with an error message\nand this is the struct for retrieving this kind of errors.","ref":"Paypal.Common.Error.html"},{"type":"type","title":"Paypal.Common.Error.t/0","doc":"The information given by Paypal for each error is as follows:\n\n- `debug_id` is the ID for debugging the error.\n- `details` is a list of details about the errors.\n- `links` is the list of links (HATEOAS).\n- `message` is the error message to try to understand why it failed.\n- `name` is the error name.","ref":"Paypal.Common.Error.html#t:t/0"},{"type":"module","title":"Paypal.Common.Link","doc":"The link is accumulating all of the required information for handling the\nHATEOAS links.","ref":"Paypal.Common.Link.html"},{"type":"type","title":"Paypal.Common.Link.t/0","doc":"The possible values for the links are:\n\n- `enc_type` is the kind of encoding the request is providing or requiring.\n  It's not compulsory for most of the links.\n- `href` is the URL for the link.\n- `rel` is the name for the link. The name is based on the RFC-8288.\n- `method` is the HTTP method that is needed for the request.","ref":"Paypal.Common.Link.html#t:t/0"},{"type":"module","title":"Paypal.Common.Operation","doc":"The operation is the struct where we store the information for the operations\nperformed in orders and payments. Most of the requests that are performing an\naction is returning an operation.","ref":"Paypal.Common.Operation.html"},{"type":"type","title":"Paypal.Common.Operation.t/0","doc":"The information provided is an `id` for the operation (order or payment),\nthe `links` for performing other actions based on the return and the\n`status` of the operation.","ref":"Paypal.Common.Operation.html#t:t/0"},{"type":"module","title":"Paypal.EctoHelpers","doc":"Ecto Helpers is a module that is ensuring we have the common functions in\nuse for most of the schemas or modules that uses Ecto.","ref":"Paypal.EctoHelpers.html"},{"type":"function","title":"Paypal.EctoHelpers.clean_data/1","doc":"Perform a cleaning of a struct converted into a map for all of the\nentries that has no content.","ref":"Paypal.EctoHelpers.html#clean_data/1"},{"type":"function","title":"Paypal.EctoHelpers.traverse_errors/1","doc":"Traverse errors is a way to retrieve in a plain format the full list of\nerrors for all of the schemas and embedded schemas under the main one.","ref":"Paypal.EctoHelpers.html#traverse_errors/1"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}